io.flutter.embedding.android

## Class FlutterView

- java.lang.Object
- - android.view.View
  - - android.view.ViewGroup
    - - android.widget.FrameLayout
      - - io.flutter.embedding.android.FlutterView

- All Implemented Interfaces:
    Drawable.Callback, AccessibilityEventSource, KeyEvent.Callback, ViewManager, ViewParent, io.flutter.plugin.mouse.MouseCursorPlugin.MouseCursorViewDelegate

      public class FlutterView
      extends FrameLayout
      implements io.flutter.plugin.mouse.MouseCursorPlugin.MouseCursorViewDelegate

  Displays a Flutter UI on an Android device.

  A `FlutterView`'s UI is painted by a corresponding `FlutterEngine`.

  A `FlutterView` can operate in 2 different `RenderMode`s:

  1. `RenderMode.surface`, which paints a Flutter UI to a `SurfaceView`. This mode has the best performance, but a `FlutterView` in this mode cannot be positioned between 2 other Android `View`s in the z-index, nor can it be animated/transformed. Unless the special capabilities of a `SurfaceTexture` are required, developers should strongly prefer this render mode.
  2. `RenderMode.texture`, which paints a Flutter UI to a `SurfaceTexture`. This mode is not as performant as `RenderMode.surface`, but a `FlutterView` in this mode can be animated and transformed, as well as positioned in the z-index between 2+ other Android `Views`. Unless the special capabilities of a `SurfaceTexture` are required, developers should strongly prefer the `RenderMode.surface` render mode.
  See https://source.android.com/devices/graphics/arch-tv#surface_or_texture for more information comparing `SurfaceView` and `TextureView`.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `FlutterView.FlutterEngineAttachmentListener` Listener that is notified when a `FlutterEngine` is attached to/detached from a given `FlutterView`.
    `static class` | `FlutterView.RenderMode` Deprecated.
    `static class` | `FlutterView.TransparencyMode` Deprecated.

    - ### Nested classes/interfaces inherited from class android.widget.FrameLayout

      `FrameLayout.LayoutParams`

    - ### Nested classes/interfaces inherited from class android.view.ViewGroup

      `ViewGroup.MarginLayoutParams, ViewGroup.OnHierarchyChangeListener`

    - ### Nested classes/interfaces inherited from class android.view.View

      `View.AccessibilityDelegate, View.AutofillFlags, View.AutofillImportance, View.AutofillType, View.BaseSavedState, View.DragShadowBuilder, View.DrawingCacheQuality, View.FindViewFlags, View.Focusable, View.FocusableMode, View.FocusDirection, View.FocusRealDirection, View.LayoutDir, View.MeasureSpec, View.OnApplyWindowInsetsListener, View.OnAttachStateChangeListener, View.OnCapturedPointerListener, View.OnClickListener, View.OnContextClickListener, View.OnCreateContextMenuListener, View.OnDragListener, View.OnFocusChangeListener, View.OnGenericMotionListener, View.OnHoverListener, View.OnKeyListener, View.OnLayoutChangeListener, View.OnLongClickListener, View.OnScrollChangeListener, View.OnSystemUiVisibilityChangeListener, View.OnTouchListener, View.OnUnhandledKeyEventListener, View.ResolvedLayoutDir, View.ScrollBarStyle, View.ScrollIndicators, View.TextAlignment, View.Visibility`

  - ### Field Summary

    - ### Fields inherited from class android.view.ViewGroup

      `CLIP_TO_PADDING_MASK, FLAG_DISALLOW_INTERCEPT, FLAG_SUPPORT_STATIC_TRANSFORMATIONS, FLAG_USE_CHILD_DRAWING_ORDER, FOCUS_AFTER_DESCENDANTS, FOCUS_BEFORE_DESCENDANTS, FOCUS_BLOCK_DESCENDANTS, LAYOUT_MODE_CLIP_BOUNDS, LAYOUT_MODE_DEFAULT, LAYOUT_MODE_OPTICAL_BOUNDS, mDisappearingChildren, mGroupFlags, mOnHierarchyChangeListener, mPersistentDrawingCache, PERSISTENT_ALL_CACHES, PERSISTENT_ANIMATION_CACHE, PERSISTENT_NO_CACHE, PERSISTENT_SCROLLING_CACHE`

    - ### Fields inherited from class android.view.View

      `ACCESSIBILITY_CURSOR_POSITION_UNDEFINED, ACCESSIBILITY_LIVE_REGION_ASSERTIVE, ACCESSIBILITY_LIVE_REGION_NONE, ACCESSIBILITY_LIVE_REGION_POLITE, ALPHA, AUTOFILL_FLAG_INCLUDE_NOT_IMPORTANT_VIEWS, AUTOFILL_HINT_CREDIT_CARD_EXPIRATION_DATE, AUTOFILL_HINT_CREDIT_CARD_EXPIRATION_DAY, AUTOFILL_HINT_CREDIT_CARD_EXPIRATION_MONTH, AUTOFILL_HINT_CREDIT_CARD_EXPIRATION_YEAR, AUTOFILL_HINT_CREDIT_CARD_NUMBER, AUTOFILL_HINT_CREDIT_CARD_SECURITY_CODE, AUTOFILL_HINT_EMAIL_ADDRESS, AUTOFILL_HINT_NAME, AUTOFILL_HINT_PASSWORD, AUTOFILL_HINT_PHONE, AUTOFILL_HINT_POSTAL_ADDRESS, AUTOFILL_HINT_POSTAL_CODE, AUTOFILL_HINT_USERNAME, AUTOFILL_TYPE_DATE, AUTOFILL_TYPE_LIST, AUTOFILL_TYPE_NONE, AUTOFILL_TYPE_TEXT, AUTOFILL_TYPE_TOGGLE, DEBUG_DRAW, DEBUG_LAYOUT_PROPERTY, DRAG_FLAG_GLOBAL, DRAG_FLAG_GLOBAL_PERSISTABLE_URI_PERMISSION, DRAG_FLAG_GLOBAL_PREFIX_URI_PERMISSION, DRAG_FLAG_GLOBAL_URI_READ, DRAG_FLAG_GLOBAL_URI_WRITE, DRAG_FLAG_OPAQUE, DRAWING_CACHE_QUALITY_AUTO, DRAWING_CACHE_QUALITY_HIGH, DRAWING_CACHE_QUALITY_LOW, EMPTY_STATE_SET, ENABLED_FOCUSED_SELECTED_STATE_SET, ENABLED_FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, ENABLED_FOCUSED_STATE_SET, ENABLED_FOCUSED_WINDOW_FOCUSED_STATE_SET, ENABLED_SELECTED_STATE_SET, ENABLED_SELECTED_WINDOW_FOCUSED_STATE_SET, ENABLED_STATE_SET, ENABLED_WINDOW_FOCUSED_STATE_SET, FIND_VIEWS_WITH_ACCESSIBILITY_NODE_PROVIDERS, FIND_VIEWS_WITH_CONTENT_DESCRIPTION, FIND_VIEWS_WITH_TEXT, FOCUS_BACKWARD, FOCUS_DOWN, FOCUS_FORWARD, FOCUS_LEFT, FOCUS_RIGHT, FOCUS_UP, FOCUSABLE, FOCUSABLE_AUTO, FOCUSABLES_ALL, FOCUSABLES_TOUCH_MODE, FOCUSED_SELECTED_STATE_SET, FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, FOCUSED_STATE_SET, FOCUSED_WINDOW_FOCUSED_STATE_SET, GONE, HAPTIC_FEEDBACK_ENABLED, IMPORTANT_FOR_ACCESSIBILITY_AUTO, IMPORTANT_FOR_ACCESSIBILITY_NO, IMPORTANT_FOR_ACCESSIBILITY_NO_HIDE_DESCENDANTS, IMPORTANT_FOR_ACCESSIBILITY_YES, IMPORTANT_FOR_AUTOFILL_AUTO, IMPORTANT_FOR_AUTOFILL_NO, IMPORTANT_FOR_AUTOFILL_NO_EXCLUDE_DESCENDANTS, IMPORTANT_FOR_AUTOFILL_YES, IMPORTANT_FOR_AUTOFILL_YES_EXCLUDE_DESCENDANTS, INVISIBLE, KEEP_SCREEN_ON, LAST_APP_AUTOFILL_ID, LAYER_TYPE_HARDWARE, LAYER_TYPE_NONE, LAYER_TYPE_SOFTWARE, LAYOUT_DIRECTION_INHERIT, LAYOUT_DIRECTION_LOCALE, LAYOUT_DIRECTION_LTR, LAYOUT_DIRECTION_RTL, LAYOUT_DIRECTION_UNDEFINED, mAttributes, mBottom, mCachingFailed, mContext, mCurrentAnimation, mDebugViewAttributes, MEASURED_HEIGHT_STATE_SHIFT, MEASURED_SIZE_MASK, MEASURED_STATE_MASK, MEASURED_STATE_TOO_SMALL, mInputEventConsistencyVerifier, mLayoutParams, mLeft, mPaddingBottom, mPaddingLeft, mPaddingRight, mPaddingTop, mParent, mPrivateFlags, mRight, mScrollX, mScrollY, mTag, mTop, mTransformationInfo, mUserPaddingBottom, mUserPaddingLeft, mUserPaddingRight, NAVIGATION_BAR_TRANSIENT, NAVIGATION_BAR_TRANSLUCENT, NAVIGATION_BAR_TRANSPARENT, NAVIGATION_BAR_UNHIDE, NO_ID, NOT_FOCUSABLE, OVER_SCROLL_ALWAYS, OVER_SCROLL_IF_CONTENT_SCROLLS, OVER_SCROLL_NEVER, PRESSED_ENABLED_FOCUSED_SELECTED_STATE_SET, PRESSED_ENABLED_FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_ENABLED_FOCUSED_STATE_SET, PRESSED_ENABLED_FOCUSED_WINDOW_FOCUSED_STATE_SET, PRESSED_ENABLED_SELECTED_STATE_SET, PRESSED_ENABLED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_ENABLED_STATE_SET, PRESSED_ENABLED_WINDOW_FOCUSED_STATE_SET, PRESSED_FOCUSED_SELECTED_STATE_SET, PRESSED_FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_FOCUSED_STATE_SET, PRESSED_FOCUSED_WINDOW_FOCUSED_STATE_SET, PRESSED_SELECTED_STATE_SET, PRESSED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_STATE_SET, PRESSED_WINDOW_FOCUSED_STATE_SET, PUBLIC_STATUS_BAR_VISIBILITY_MASK, ROTATION, ROTATION_X, ROTATION_Y, SCALE_X, SCALE_Y, SCREEN_STATE_OFF, SCREEN_STATE_ON, SCROLL_AXIS_HORIZONTAL, SCROLL_AXIS_NONE, SCROLL_AXIS_VERTICAL, SCROLL_INDICATOR_BOTTOM, SCROLL_INDICATOR_END, SCROLL_INDICATOR_LEFT, SCROLL_INDICATOR_RIGHT, SCROLL_INDICATOR_START, SCROLL_INDICATOR_TOP, SCROLLBAR_POSITION_DEFAULT, SCROLLBAR_POSITION_LEFT, SCROLLBAR_POSITION_RIGHT, SCROLLBARS_INSIDE_INSET, SCROLLBARS_INSIDE_OVERLAY, SCROLLBARS_OUTSIDE_INSET, SCROLLBARS_OUTSIDE_OVERLAY, SELECTED_STATE_SET, SELECTED_WINDOW_FOCUSED_STATE_SET, SOUND_EFFECTS_ENABLED, sPreserveMarginParamsInLayoutParamConversion, STATUS_BAR_DISABLE_BACK, STATUS_BAR_DISABLE_CLOCK, STATUS_BAR_DISABLE_EXPAND, STATUS_BAR_DISABLE_HOME, STATUS_BAR_DISABLE_NOTIFICATION_ALERTS, STATUS_BAR_DISABLE_NOTIFICATION_ICONS, STATUS_BAR_DISABLE_NOTIFICATION_TICKER, STATUS_BAR_DISABLE_RECENT, STATUS_BAR_DISABLE_SEARCH, STATUS_BAR_DISABLE_SYSTEM_INFO, STATUS_BAR_HIDDEN, STATUS_BAR_TRANSIENT, STATUS_BAR_TRANSLUCENT, STATUS_BAR_TRANSPARENT, STATUS_BAR_UNHIDE, STATUS_BAR_VISIBLE, SYSTEM_UI_CLEARABLE_FLAGS, SYSTEM_UI_FLAG_FULLSCREEN, SYSTEM_UI_FLAG_HIDE_NAVIGATION, SYSTEM_UI_FLAG_IMMERSIVE, SYSTEM_UI_FLAG_IMMERSIVE_STICKY, SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN, SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION, SYSTEM_UI_FLAG_LAYOUT_STABLE, SYSTEM_UI_FLAG_LIGHT_NAVIGATION_BAR, SYSTEM_UI_FLAG_LIGHT_STATUS_BAR, SYSTEM_UI_FLAG_LOW_PROFILE, SYSTEM_UI_FLAG_VISIBLE, SYSTEM_UI_LAYOUT_FLAGS, SYSTEM_UI_TRANSPARENT, TEXT_ALIGNMENT_CENTER, TEXT_ALIGNMENT_GRAVITY, TEXT_ALIGNMENT_INHERIT, TEXT_ALIGNMENT_TEXT_END, TEXT_ALIGNMENT_TEXT_START, TEXT_ALIGNMENT_VIEW_END, TEXT_ALIGNMENT_VIEW_START, TEXT_DIRECTION_ANY_RTL, TEXT_DIRECTION_FIRST_STRONG, TEXT_DIRECTION_FIRST_STRONG_LTR, TEXT_DIRECTION_FIRST_STRONG_RTL, TEXT_DIRECTION_INHERIT, TEXT_DIRECTION_LOCALE, TEXT_DIRECTION_LTR, TEXT_DIRECTION_RTL, TRANSLATION_X, TRANSLATION_Y, TRANSLATION_Z, VIEW_LOG_TAG, VISIBLE, WINDOW_FOCUSED_STATE_SET, X, Y, Z`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FlutterView(Context context)` Constructs a `FlutterView` programmatically, without any XML attributes.
    `FlutterView(Context context, AttributeSet attrs)` Constructs a `FlutterView` in an XML-inflation-compliant manner.
    `FlutterView(Context context, FlutterImageView flutterImageView)` Constructs a `FlutterView` programmatically, without any XML attributes, uses the given `FlutterImageView` to render the Flutter UI.
    `FlutterView(Context context, FlutterSurfaceView flutterSurfaceView)` Constructs a `FlutterView` programmatically, without any XML attributes, uses the given `FlutterSurfaceView` to render the Flutter UI, and allows selection of a `transparencyMode`.
    `FlutterView(Context context, FlutterTextureView flutterTextureView)` Constructs a `FlutterView` programmatically, without any XML attributes, uses the given `FlutterTextureView` to render the Flutter UI, and allows selection of a `transparencyMode`.
    `FlutterView(Context context, FlutterView.RenderMode renderMode)` Deprecated.
    `FlutterView(Context context, FlutterView.RenderMode renderMode, FlutterView.TransparencyMode transparencyMode)` Deprecated.
    `FlutterView(Context context, FlutterView.TransparencyMode transparencyMode)` Deprecated.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `acquireLatestImageViewFrame()`
    `void` | `addFlutterEngineAttachmentListener(FlutterView.FlutterEngineAttachmentListener listener)` Adds a `FlutterView.FlutterEngineAttachmentListener`, which is notified whenever this `FlutterView` attached to/detaches from a `FlutterEngine`.
    `void` | `addOnFirstFrameRenderedListener(FlutterUiDisplayListener listener)` Adds the given `listener` to this `FlutterView`, to be notified upon Flutter's first rendered frame.
    `void` | `attachOverlaySurfaceToRender(FlutterImageView view)`
    `void` | `attachToFlutterEngine(FlutterEngine flutterEngine)` Connects this `FlutterView` to the given `FlutterEngine`.
    `void` | `autofill(SparseArray<AutofillValue> values)`
    `boolean` | `checkInputConnectionProxy(View view)` Allows a `View` that is not currently the input connection target to invoke commands on the `InputMethodManager`, which is otherwise disallowed.
    `void` | `convertToImageView()` Converts the current render surface to a `FlutterImageView` if it's not one already.
    `FlutterImageView` | `createImageView()`
    `void` | `detachFromFlutterEngine()` Disconnects this `FlutterView` from a previously attached `FlutterEngine`.
    `boolean` | `dispatchKeyEvent(KeyEvent event)` Invoked when a hardware key is pressed or released.
    `protected boolean` | `fitSystemWindows(Rect insets)` Invoked when Android's desired window insets change, i.e., padding.
    `AccessibilityNodeProvider` | `getAccessibilityNodeProvider()`
    `FlutterEngine` | `getAttachedFlutterEngine()` Returns the `FlutterEngine` to which this `FlutterView` is currently attached, or null if this `FlutterView` is not currently attached to a `FlutterEngine`.
    `PointerIcon` | `getSystemPointerIcon(int type)` Gets a system pointer icon object for the given `type`.
    `boolean` | `hasRenderedFirstFrame()` Returns true if an attached `FlutterEngine` has rendered at least 1 frame to this `FlutterView`.
    `boolean` | `isAttachedToFlutterEngine()` Returns true if this `FlutterView` is currently attached to a `FlutterEngine`.
    `WindowInsets` | `onApplyWindowInsets(WindowInsets insets)` Invoked when Android's desired window insets change, i.e., padding.
    `protected void` | `onConfigurationChanged(Configuration newConfig)` Sends relevant configuration data from Android to Flutter when the Android `Configuration` changes.
    `InputConnection` | `onCreateInputConnection(EditorInfo outAttrs)` Creates an `InputConnection` to work with a `InputMethodManager`.
    `boolean` | `onGenericMotionEvent(MotionEvent event)` Invoked by Android when a generic motion event occurs, e.g., joystick movement, mouse hover, track pad touches, scroll wheel movements, etc.
    `boolean` | `onHoverEvent(MotionEvent event)` Invoked by Android when a hover-compliant input system causes a hover event.
    `void` | `onProvideAutofillVirtualStructure(ViewStructure structure, int flags)`
    `protected void` | `onSizeChanged(int width, int height, int oldWidth, int oldHeight)` Invoked when this `FlutterView` changes size, including upon initial measure.
    `boolean` | `onTouchEvent(MotionEvent event)` Invoked by Android when a user touch event occurs.
    `void` | `removeFlutterEngineAttachmentListener(FlutterView.FlutterEngineAttachmentListener listener)` Removes a `FlutterView.FlutterEngineAttachmentListener` that was previously added with `addFlutterEngineAttachmentListener(FlutterEngineAttachmentListener)`.
    `void` | `removeOnFirstFrameRenderedListener(FlutterUiDisplayListener listener)` Removes the given `listener`, which was previously added with `addOnFirstFrameRenderedListener(FlutterUiDisplayListener)`.
    `void` | `revertImageView(Runnable onDone)` If the surface is rendered by a `FlutterImageView`, then calling this method will stop rendering to a `FlutterImageView`, and render on the previous surface instead.

    - ### Methods inherited from class android.widget.FrameLayout

      `checkLayoutParams, encodeProperties, generateDefaultLayoutParams, generateLayoutParams, generateLayoutParams, getAccessibilityClassName, getConsiderGoneChildrenWhenMeasuring, getMeasureAllChildren, onLayout, onMeasure, setForegroundGravity, setMeasureAllChildren, shouldDelayChildPressedState`

    - ### Methods inherited from class android.view.ViewGroup

      `addChildrenForAccessibility, addFocusables, addKeyboardNavigationClusters, addStatesFromChildren, addTouchables, addTransientView, addView, addView, addView, addView, addView, addViewInLayout, addViewInLayout, attachLayoutAnimationParameters, attachViewToParent, bringChildToFront, buildTouchDispatchChildList, canAnimate, captureTransitioningViews, childDrawableStateChanged, childHasTransientStateChanged, cleanupLayoutState, clearChildFocus, clearDisappearingChildren, clearFocus, createSnapshot, debug, destroyHardwareResources, detachAllViewsFromParent, detachViewFromParent, detachViewFromParent, detachViewsFromParent, dispatchActivityResult, dispatchApplyWindowInsets, dispatchCapturedPointerEvent, dispatchConfigurationChanged, dispatchDisplayHint, dispatchDragEvent, dispatchDraw, dispatchDrawableHotspotChanged, dispatchFinishTemporaryDetach, dispatchFreezeSelfOnly, dispatchGenericFocusedEvent, dispatchGenericPointerEvent, dispatchGetDisplayList, dispatchHoverEvent, dispatchKeyEventPreIme, dispatchKeyShortcutEvent, dispatchPointerCaptureChanged, dispatchPopulateAccessibilityEventInternal, dispatchProvideAutofillStructure, dispatchProvideStructure, dispatchRestoreInstanceState, dispatchSaveInstanceState, dispatchSetActivated, dispatchSetPressed, dispatchSetSelected, dispatchStartTemporaryDetach, dispatchSystemUiVisibilityChanged, dispatchThawSelfOnly, dispatchTouchEvent, dispatchTrackballEvent, dispatchUnhandledMove, dispatchVisibilityChanged, dispatchWindowFocusChanged, dispatchWindowSystemUiVisiblityChanged, dispatchWindowVisibilityChanged, drawableStateChanged, drawChild, endViewTransition, findFocus, findNamedViews, findViewByAccessibilityIdTraversal, findViewByAutofillIdTraversal, findViewByPredicateTraversal, findViewsWithText, findViewTraversal, findViewWithTagTraversal, focusableViewAvailable, focusSearch, gatherTransparentRegion, getChildAt, getChildCount, getChildDrawingOrder, getChildMeasureSpec, getChildStaticTransformation, getChildVisibleRect, getChildVisibleRect, getClipChildren, getClipToPadding, getDescendantFocusability, getFocusedChild, getLayoutAnimation, getLayoutAnimationListener, getLayoutMode, getLayoutTransition, getNestedScrollAxes, getOverlay, getPersistentDrawingCache, getTouchscreenBlocksFocus, getTransientView, getTransientViewCount, getTransientViewIndex, hasFocus, hasHoveredChild, hasTransientState, indexOfChild, internalSetPadding, invalidateChild, invalidateChildInParent, isAlwaysDrawnWithCacheEnabled, isAnimationCacheEnabled, isChildrenDrawingOrderEnabled, isChildrenDrawnWithCacheEnabled, isLayoutSuppressed, isMotionEventSplittingEnabled, isShowingContextMenuWithCoords, isTransformedTouchPointInView, isTransitionGroup, jumpDrawablesToCurrentState, layout, makeOptionalFitsSystemWindows, measureChild, measureChildren, measureChildWithMargins, notifySubtreeAccessibilityStateChanged, notifySubtreeAccessibilityStateChangedIfNeeded, offsetChildrenTopAndBottom, offsetDescendantRectToMyCoords, offsetRectIntoDescendantCoords, onAttachedToWindow, onChildVisibilityChanged, onCreateDrawableState, onDebugDraw, onDebugDrawMargins, onDescendantInvalidated, onDetachedFromWindow, onInitializeAccessibilityNodeInfoInternal, onInterceptHoverEvent, onInterceptTouchEvent, onNestedFling, onNestedPreFling, onNestedPrePerformAccessibilityAction, onNestedPreScroll, onNestedScroll, onNestedScrollAccepted, onRequestFocusInDescendants, onRequestSendAccessibilityEvent, onRequestSendAccessibilityEventInternal, onResolvePointerIcon, onSetLayoutParams, onStartNestedScroll, onStopNestedScroll, onViewAdded, onViewRemoved, recomputeViewAttributes, removeAllViews, removeAllViewsInLayout, removeDetachedView, removeTransientView, removeView, removeViewAt, removeViewInLayout, removeViews, removeViewsInLayout, requestChildFocus, requestChildRectangleOnScreen, requestDisallowInterceptTouchEvent, requestFocus, requestSendAccessibilityEvent, requestTransitionStart, requestTransparentRegion, resetResolvedDrawables, resetResolvedLayoutDirection, resetResolvedPadding, resetResolvedTextAlignment, resetResolvedTextDirection, resolveDrawables, resolveLayoutDirection, resolveLayoutParams, resolvePadding, resolveRtlPropertiesIfNeeded, resolveTextAlignment, resolveTextDirection, restoreDefaultFocus, restoreFocusInCluster, restoreFocusNotInCluster, scheduleLayoutAnimation, setAddStatesFromChildren, setAlwaysDrawnWithCacheEnabled, setAnimationCacheEnabled, setChildrenDrawingCacheEnabled, setChildrenDrawingOrderEnabled, setChildrenDrawnWithCacheEnabled, setClipChildren, setClipToPadding, setDescendantFocusability, setLayoutAnimation, setLayoutAnimationListener, setLayoutMode, setLayoutTransition, setMotionEventSplittingEnabled, setOnHierarchyChangeListener, setPersistentDrawingCache, setStaticTransformationsEnabled, setTouchscreenBlocksFocus, setTransitionGroup, showContextMenuForChild, showContextMenuForChild, startActionModeForChild, startActionModeForChild, startLayoutAnimation, startViewTransition, suppressLayout, transformPointToViewLocal, updateViewLayout`

    - ### Methods inherited from class android.view.View

      `addExtraDataToAccessibilityNodeInfo, addFocusables, addFrameMetricsListener, addOnAttachStateChangeListener, addOnLayoutChangeListener, addOnUnhandledKeyEventListener, animate, announceForAccessibility, applyDrawableToTransparentRegion, autofill, awakenScrollBars, awakenScrollBars, awakenScrollBars, bringToFront, buildDrawingCache, buildDrawingCache, buildLayer, callOnClick, cancelDragAndDrop, cancelLongPress, cancelPendingInputEvents, canHaveDisplayList, canNotifyAutofillEnterExitEvent, canResolveLayoutDirection, canResolveTextAlignment, canResolveTextDirection, canScrollHorizontally, canScrollVertically, clearAccessibilityFocus, clearAnimation, combineMeasuredStates, computeFitSystemWindows, computeHorizontalScrollExtent, computeHorizontalScrollOffset, computeHorizontalScrollRange, computeOpaqueFlags, computeScroll, computeSystemWindowInsets, computeVerticalScrollExtent, computeVerticalScrollOffset, computeVerticalScrollRange, createAccessibilityNodeInfo, createAccessibilityNodeInfoInternal, createContextMenu, damageInParent, debug, debugIndent, destroyDrawingCache, dispatchGenericMotionEvent, dispatchNestedFling, dispatchNestedPreFling, dispatchNestedPrePerformAccessibilityAction, dispatchNestedPreScroll, dispatchNestedScroll, dispatchPointerEvent, dispatchPopulateAccessibilityEvent, draw, drawableHotspotChanged, encode, findViewById, findViewByPredicate, findViewByPredicateInsideOut, findViewWithTag, fitsSystemWindows, focusSearch, forceHasOverlappingRendering, forceLayout, generateViewId, getAccessibilityDelegate, getAccessibilityLiveRegion, getAccessibilityPaneTitle, getAccessibilitySelectionEnd, getAccessibilitySelectionStart, getAccessibilityTraversalAfter, getAccessibilityTraversalBefore, getAccessibilityViewId, getAccessibilityWindowId, getAlpha, getAnimation, getApplicationWindowToken, getAutofillHints, getAutofillId, getAutofillType, getAutofillValue, getAutofillViewId, getBackground, getBackgroundTintList, getBackgroundTintMode, getBaseline, getBottom, getBottomFadingEdgeStrength, getBottomPaddingOffset, getBoundsOnScreen, getBoundsOnScreen, getCameraDistance, getClipBounds, getClipBounds, getClipToOutline, getContentDescription, getContext, getContextMenuInfo, getDefaultFocusHighlightEnabled, getDefaultSize, getDisplay, getDrawableState, getDrawingCache, getDrawingCache, getDrawingCacheBackgroundColor, getDrawingCacheQuality, getDrawingRect, getDrawingTime, getElevation, getFadeHeight, getFadeTop, getFilterTouchesWhenObscured, getFitsSystemWindows, getFocusable, getFocusables, getFocusedRect, getForeground, getForegroundGravity, getForegroundTintList, getForegroundTintMode, getGlobalVisibleRect, getGlobalVisibleRect, getHandler, getHasOverlappingRendering, getHeight, getHitRect, getHorizontalFadingEdgeLength, getHorizontalScrollbarHeight, getHorizontalScrollFactor, getHotspotBounds, getId, getImportantForAccessibility, getImportantForAutofill, getInverseMatrix, getIterableTextForAccessibility, getIteratorForGranularity, getKeepScreenOn, getKeyDispatcherState, getLabelFor, getLayerType, getLayoutDirection, getLayoutParams, getLeft, getLeftFadingEdgeStrength, getLeftPaddingOffset, getLocalVisibleRect, getLocationInSurface, getLocationInWindow, getLocationOnScreen, getLocationOnScreen, getMatrix, getMeasuredHeight, getMeasuredHeightAndState, getMeasuredState, getMeasuredWidth, getMeasuredWidthAndState, getMinimumHeight, getMinimumWidth, getNextClusterForwardId, getNextFocusDownId, getNextFocusForwardId, getNextFocusLeftId, getNextFocusRightId, getNextFocusUpId, getOnFocusChangeListener, getOpticalInsets, getOutlineAmbientShadowColor, getOutlineProvider, getOutlineSpotShadowColor, getOutsets, getOverScrollMode, getPaddingBottom, getPaddingEnd, getPaddingLeft, getPaddingRight, getPaddingStart, getPaddingTop, getParent, getParentForAccessibility, getPivotX, getPivotY, getPointerIcon, getRawLayoutDirection, getRawTextAlignment, getRawTextDirection, getResources, getRevealOnFocusHint, getRight, getRightFadingEdgeStrength, getRightPaddingOffset, getRootView, getRootWindowInsets, getRotation, getRotationX, getRotationY, getScaleX, getScaleY, getScrollBarDefaultDelayBeforeFade, getScrollBarFadeDuration, getScrollBarSize, getScrollBarStyle, getScrollIndicators, getScrollX, getScrollY, getSolidColor, getStateListAnimator, getSuggestedMinimumHeight, getSuggestedMinimumWidth, getSystemUiVisibility, getTag, getTag, getTextAlignment, getTextDirection, getThreadedRenderer, getTooltip, getTooltipText, getTooltipView, getTop, getTopFadingEdgeStrength, getTopPaddingOffset, getTouchables, getTouchDelegate, getTransitionAlpha, getTransitionName, getTranslationX, getTranslationY, getTranslationZ, getVerticalFadingEdgeLength, getVerticalScrollbarPosition, getVerticalScrollbarWidth, getVerticalScrollFactor, getViewRootImpl, getViewTreeObserver, getVisibility, getWidth, getWindow, getWindowAttachCount, getWindowDisplayFrame, getWindowId, getWindowSystemUiVisibility, getWindowToken, getWindowVisibility, getWindowVisibleDisplayFrame, getX, getY, getZ, handleScrollBarDragging, hasExplicitFocusable, hasFocusable, hasNestedScrollingParent, hasOnClickListeners, hasOpaqueScrollbars, hasOverlappingRendering, hasPointerCapture, hasShadow, hasWindowFocus, includeForAccessibility, inflate, initializeFadingEdge, initializeFadingEdgeInternal, initializeScrollbars, initializeScrollbarsInternal, invalidate, invalidate, invalidate, invalidate, invalidateDrawable, invalidateOutline, invalidateParentCaches, invalidateParentIfNeeded, invalidateParentIfNeededAndWasQuickRejected, isAccessibilityFocused, isAccessibilityHeading, isAccessibilitySelectionExtendable, isActionableForAccessibility, isActivated, isAssistBlocked, isAttachedToWindow, isAutofilled, isClickable, isContextClickable, isDefaultFocusHighlightEnabled, isDefaultFocusHighlightNeeded, isDirty, isDrawingCacheEnabled, isDuplicateParentStateEnabled, isEnabled, isFocusable, isFocusableInTouchMode, isFocused, isFocusedByDefault, isForegroundInsidePadding, isHapticFeedbackEnabled, isHardwareAccelerated, isHorizontalFadingEdgeEnabled, isHorizontalScrollBarEnabled, isHovered, isImportantForAccessibility, isImportantForAutofill, isInEditMode, isInLayout, isInScrollingContainer, isInTouchMode, isKeyboardNavigationCluster, isLaidOut, isLayoutDirectionInherited, isLayoutDirectionResolved, isLayoutModeOptical, isLayoutRequested, isLayoutRtl, isLongClickable, isNestedScrollingEnabled, isOpaque, isPaddingOffsetRequired, isPaddingRelative, isPivotSet, isPressed, isRootNamespace, isSaveEnabled, isSaveFromParentEnabled, isScreenReaderFocusable, isScrollbarFadingEnabled, isScrollContainer, isSelected, isShown, isSoundEffectsEnabled, isTemporarilyDetached, isTextAlignmentInherited, isTextAlignmentResolved, isTextDirectionInherited, isTextDirectionResolved, isVerticalFadingEdgeEnabled, isVerticalScrollBarEnabled, isVerticalScrollBarHidden, isVisibleToUser, isVisibleToUser, isVisibleToUserForAutofill, keyboardNavigationClusterSearch, mapRectFromViewToScreenCoords, measure, mergeDrawableStates, notifyEnterOrExitForAutoFillIfNeeded, notifyViewAccessibilityStateChangedIfNeeded, offsetLeftAndRight, offsetTopAndBottom, onActivityResult, onAnimationEnd, onAnimationStart, onCancelPendingInputEvents, onCapturedPointerEvent, onCheckIsTextEditor, onCloseSystemDialogs, onCreateContextMenu, onDetachedFromWindowInternal, onDisplayHint, onDragEvent, onDraw, onDrawForeground, onDrawHorizontalScrollBar, onDrawScrollBars, onDrawVerticalScrollBar, onFilterTouchEventForSecurity, onFinishInflate, onFinishTemporaryDetach, onFocusChanged, onFocusLost, onHoverChanged, onInitializeAccessibilityEvent, onInitializeAccessibilityEventInternal, onInitializeAccessibilityNodeInfo, onKeyDown, onKeyLongPress, onKeyMultiple, onKeyPreIme, onKeyShortcut, onKeyUp, onMovedToDisplay, onOverScrolled, onPointerCaptureChange, onPopulateAccessibilityEvent, onPopulateAccessibilityEventInternal, onProvideAutofillStructure, onProvideStructure, onProvideVirtualStructure, onResolveDrawables, onRestoreInstanceState, onRtlPropertiesChanged, onSaveInstanceState, onScreenStateChanged, onScrollChanged, onSetAlpha, onStartTemporaryDetach, onTrackballEvent, onVisibilityAggregated, onVisibilityChanged, onWindowFocusChanged, onWindowSystemUiVisibilityChanged, onWindowVisibilityChanged, outputDirtyFlags, overScrollBy, performAccessibilityAction, performAccessibilityActionInternal, performButtonActionOnTouchDown, performClick, performContextClick, performContextClick, performHapticFeedback, performHapticFeedback, performLongClick, performLongClick, playSoundEffect, pointInView, post, postDelayed, postInvalidate, postInvalidate, postInvalidateDelayed, postInvalidateDelayed, postInvalidateOnAnimation, postInvalidateOnAnimation, postOnAnimation, postOnAnimationDelayed, recomputePadding, refreshDrawableState, releasePointerCapture, removeCallbacks, removeFrameMetricsListener, removeOnAttachStateChangeListener, removeOnLayoutChangeListener, removeOnUnhandledKeyEventListener, requestAccessibilityFocus, requestApplyInsets, requestFitSystemWindows, requestFocus, requestFocus, requestFocusFromTouch, requestKeyboardShortcuts, requestLayout, requestPointerCapture, requestRectangleOnScreen, requestRectangleOnScreen, requestUnbufferedDispatch, requireViewById, resetPaddingToInitialValues, resetPivot, resetRtlProperties, resolveSize, resolveSizeAndState, restoreHierarchyState, saveHierarchyState, scheduleDrawable, scrollBy, scrollTo, sendAccessibilityEvent, sendAccessibilityEventInternal, sendAccessibilityEventUnchecked, sendAccessibilityEventUncheckedInternal, setAccessibilityDelegate, setAccessibilityHeading, setAccessibilityLiveRegion, setAccessibilityPaneTitle, setAccessibilitySelection, setAccessibilityTraversalAfter, setAccessibilityTraversalBefore, setActivated, setAlpha, setAnimation, setAnimationMatrix, setAssistBlocked, setAutofilled, setAutofillHints, setAutofillId, setBackground, setBackgroundColor, setBackgroundDrawable, setBackgroundResource, setBackgroundTintList, setBackgroundTintMode, setBottom, setCameraDistance, setClickable, setClipBounds, setClipToOutline, setContentDescription, setContextClickable, setDefaultFocusHighlightEnabled, setDisabledSystemUiVisibility, setDrawingCacheBackgroundColor, setDrawingCacheEnabled, setDrawingCacheQuality, setDuplicateParentStateEnabled, setElevation, setEnabled, setFadingEdgeLength, setFilterTouchesWhenObscured, setFitsSystemWindows, setFocusable, setFocusable, setFocusableInTouchMode, setFocusedByDefault, setFocusedInCluster, setForeground, setForegroundTintList, setForegroundTintMode, setFrame, setHapticFeedbackEnabled, setHasTransientState, setHorizontalFadingEdgeEnabled, setHorizontalScrollBarEnabled, setHovered, setId, setImportantForAccessibility, setImportantForAutofill, setIsRootNamespace, setKeepScreenOn, setKeyboardNavigationCluster, setLabelFor, setLayerPaint, setLayerType, setLayoutDirection, setLayoutParams, setLeft, setLeftTopRightBottom, setLongClickable, setMeasuredDimension, setMinimumHeight, setMinimumWidth, setNestedScrollingEnabled, setNextClusterForwardId, setNextFocusDownId, setNextFocusForwardId, setNextFocusLeftId, setNextFocusRightId, setNextFocusUpId, setNotifyAutofillManagerOnClick, setOnApplyWindowInsetsListener, setOnCapturedPointerListener, setOnClickListener, setOnContextClickListener, setOnCreateContextMenuListener, setOnDragListener, setOnFocusChangeListener, setOnGenericMotionListener, setOnHoverListener, setOnKeyListener, setOnLongClickListener, setOnScrollChangeListener, setOnSystemUiVisibilityChangeListener, setOnTouchListener, setOpticalInsets, setOutlineAmbientShadowColor, setOutlineProvider, setOutlineSpotShadowColor, setOverScrollMode, setPadding, setPaddingRelative, setPivotX, setPivotY, setPointerIcon, setPressed, setRevealClip, setRevealOnFocusHint, setRight, setRotation, setRotationX, setRotationY, setSaveEnabled, setSaveFromParentEnabled, setScaleX, setScaleY, setScreenReaderFocusable, setScrollBarDefaultDelayBeforeFade, setScrollBarFadeDuration, setScrollbarFadingEnabled, setScrollBarSize, setScrollBarStyle, setScrollContainer, setScrollIndicators, setScrollIndicators, setScrollX, setScrollY, setSelected, setSoundEffectsEnabled, setStateListAnimator, setSystemUiVisibility, setTag, setTag, setTagInternal, setTextAlignment, setTextDirection, setTooltip, setTooltipText, setTop, setTouchDelegate, setTransitionAlpha, setTransitionName, setTransitionVisibility, setTranslationX, setTranslationY, setTranslationZ, setVerticalFadingEdgeEnabled, setVerticalScrollBarEnabled, setVerticalScrollbarPosition, setVisibility, setWillNotCacheDrawing, setWillNotDraw, setX, setY, setZ, showContextMenu, showContextMenu, startActionMode, startActionMode, startActivityForResult, startAnimation, startDrag, startDragAndDrop, startMovingTask, startNestedScroll, stopNestedScroll, toGlobalMotionEvent, toLocalMotionEvent, toString, transformFromViewToWindowSpace, transformMatrixToGlobal, transformMatrixToLocal, unscheduleDrawable, unscheduleDrawable, updateDisplayListIfDirty, updateDragShadow, verifyDrawable, willNotCacheDrawing, willNotDraw`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface io.flutter.plugin.mouse.MouseCursorPlugin.MouseCursorViewDelegate

      `setPointerIcon`

    - ### Methods inherited from interface android.view.ViewParent

      `canResolveLayoutDirection, canResolveTextAlignment, canResolveTextDirection, createContextMenu, getLayoutDirection, getParent, getParentForAccessibility, getTextAlignment, getTextDirection, isLayoutDirectionResolved, isLayoutRequested, isTextAlignmentResolved, isTextDirectionResolved, keyboardNavigationClusterSearch, requestFitSystemWindows, requestLayout`

- - ### Constructor Detail

    - #### FlutterView

          public FlutterView(@NonNull
                             Context context)

      Constructs a `FlutterView` programmatically, without any XML attributes.

      - A `FlutterSurfaceView` is used to render the Flutter UI.
      - `transparencyMode` defaults to `TransparencyMode.opaque`.
      `FlutterView` requires an `Activity` instead of a generic `Context` to be compatible with `PlatformViewsController`.

    - #### FlutterView

          @Deprecated
          public FlutterView(@NonNull
                                         Context context,
                                         @NonNull
                                         FlutterView.RenderMode renderMode)

      Deprecated.
      Deprecated - use `FlutterView(Context, FlutterSurfaceView)` or `FlutterView(Context, FlutterTextureView)` or `FlutterView(Context, FlutterImageView)` instead.

    - #### FlutterView

          @Deprecated
          public FlutterView(@NonNull
                                         Context context,
                                         @NonNull
                                         FlutterView.TransparencyMode transparencyMode)

      Deprecated.
      Deprecated - use `FlutterView(Context, FlutterSurfaceView)` or `FlutterView(Context, FlutterTextureView)` instead, and configure the incoming `FlutterSurfaceView` or `FlutterTextureView` for transparency as desired.

      Constructs a `FlutterView` programmatically, without any XML attributes, uses a `FlutterSurfaceView` to render the Flutter UI, and allows selection of a `transparencyMode`.

      `FlutterView` requires an `Activity` instead of a generic `Context` to be compatible with `PlatformViewsController`.

    - #### FlutterView

          public FlutterView(@NonNull
                             Context context,
                             @NonNull
                             FlutterSurfaceView flutterSurfaceView)

      Constructs a `FlutterView` programmatically, without any XML attributes, uses the given `FlutterSurfaceView` to render the Flutter UI, and allows selection of a `transparencyMode`.

      `FlutterView` requires an `Activity` instead of a generic `Context` to be compatible with `PlatformViewsController`.

    - #### FlutterView

          public FlutterView(@NonNull
                             Context context,
                             @NonNull
                             FlutterTextureView flutterTextureView)

      Constructs a `FlutterView` programmatically, without any XML attributes, uses the given `FlutterTextureView` to render the Flutter UI, and allows selection of a `transparencyMode`.

      `FlutterView` requires an `Activity` instead of a generic `Context` to be compatible with `PlatformViewsController`.

    - #### FlutterView

          public FlutterView(@NonNull
                             Context context,
                             @NonNull
                             FlutterImageView flutterImageView)

      Constructs a `FlutterView` programmatically, without any XML attributes, uses the given `FlutterImageView` to render the Flutter UI.

      `FlutterView` requires an `Activity` instead of a generic `Context` to be compatible with `PlatformViewsController`.

    - #### FlutterView

          public FlutterView(@NonNull
                             Context context,
                             @Nullable
                             AttributeSet attrs)

      Constructs a `FlutterView` in an XML-inflation-compliant manner.

      `FlutterView` requires an `Activity` instead of a generic `Context` to be compatible with `PlatformViewsController`.

    - #### FlutterView

          @Deprecated
          public FlutterView(@NonNull
                                         Context context,
                                         @NonNull
                                         FlutterView.RenderMode renderMode,
                                         @NonNull
                                         FlutterView.TransparencyMode transparencyMode)

      Deprecated.
      Deprecated - use `FlutterView(Context, FlutterSurfaceView)` or `FlutterView(Context, FlutterTextureView)` instead, and configure the incoming `FlutterSurfaceView` or `FlutterTextureView` for transparency as desired.

  - ### Method Detail

    - #### hasRenderedFirstFrame

          public boolean hasRenderedFirstFrame()

      Returns true if an attached `FlutterEngine` has rendered at least 1 frame to this `FlutterView`.

      Returns false if no `FlutterEngine` is attached.

      This flag is specific to a given `FlutterEngine`. The following hypothetical timeline demonstrates how this flag changes over time.

      1. `flutterEngineA` is attached to this `FlutterView`: returns false
      2. `flutterEngineA` renders its first frame to this `FlutterView`: returns true
      3. `flutterEngineA` is detached from this `FlutterView`: returns false
      4. `flutterEngineB` is attached to this `FlutterView`: returns false
      5. `flutterEngineB` renders its first frame to this `FlutterView`: returns true

    - #### addOnFirstFrameRenderedListener

          public void addOnFirstFrameRenderedListener(@NonNull
                                                      FlutterUiDisplayListener listener)

      Adds the given `listener` to this `FlutterView`, to be notified upon Flutter's first rendered frame.

    - #### removeOnFirstFrameRenderedListener

          public void removeOnFirstFrameRenderedListener(@NonNull
                                                         FlutterUiDisplayListener listener)

      Removes the given `listener`, which was previously added with `addOnFirstFrameRenderedListener(FlutterUiDisplayListener)`.

    - #### onConfigurationChanged

          protected void onConfigurationChanged(@NonNull
                                                Configuration newConfig)

      Sends relevant configuration data from Android to Flutter when the Android `Configuration` changes.

      The Android `Configuration` might change as a result of device orientation change, device language change, device text scale factor change, etc.

      Overrides:
        `onConfigurationChanged` in class `View`

    - #### onSizeChanged

          protected void onSizeChanged(int width,
                                       int height,
                                       int oldWidth,
                                       int oldHeight)

      Invoked when this `FlutterView` changes size, including upon initial measure.

      The initial measure reports an `oldWidth` and `oldHeight` of zero.

      Flutter cares about the width and height of the view that displays it on the host platform. Therefore, when this method is invoked, the new width and height are communicated to Flutter as the "physical size" of the view that displays Flutter's UI.

      Overrides:
        `onSizeChanged` in class `View`

    - #### onApplyWindowInsets

          @NonNull
          public final WindowInsets onApplyWindowInsets(@NonNull
                                                                 WindowInsets insets)

      Invoked when Android's desired window insets change, i.e., padding.

      Flutter does not use a standard `View` hierarchy and therefore Flutter is unaware of these insets. Therefore, this method calculates the viewport metrics that Flutter should use and then sends those metrics to Flutter.

      This callback is not present in API < 20, which means lower API devices will see the wider than expected padding when the status and navigation bars are hidden.

      Overrides:
        `onApplyWindowInsets` in class `View`

    - #### fitSystemWindows

          protected boolean fitSystemWindows(@NonNull
                                             Rect insets)

      Invoked when Android's desired window insets change, i.e., padding.

      `fitSystemWindows` is an earlier version of `onApplyWindowInsets(WindowInsets)`. See that method for more details about how window insets relate to Flutter.

      Overrides:
        `fitSystemWindows` in class `View`

    - #### onCreateInputConnection

          @Nullable
          public InputConnection onCreateInputConnection(@NonNull
                                                                   EditorInfo outAttrs)

      Creates an `InputConnection` to work with a `InputMethodManager`.

      Any `View` that can take focus or process text input must implement this method by returning a non-null `InputConnection`. Flutter may render one or many focusable and text-input widgets, therefore `FlutterView` must support an `InputConnection`.

      The `InputConnection` returned from this method comes from a `TextInputPlugin`, which is owned by this `FlutterView`. A `TextInputPlugin` exists to encapsulate the nuances of input communication, rather than spread that logic throughout this `FlutterView`.

      Overrides:
        `onCreateInputConnection` in class `View`

    - #### checkInputConnectionProxy

          public boolean checkInputConnectionProxy(View view)

      Allows a `View` that is not currently the input connection target to invoke commands on the `InputMethodManager`, which is otherwise disallowed.

      Returns true to allow non-input-connection-targets to invoke methods on `InputMethodManager`, or false to exclusively allow the input connection target to invoke such methods.

      Overrides:
        `checkInputConnectionProxy` in class `View`

    - #### dispatchKeyEvent

          public boolean dispatchKeyEvent(KeyEvent event)

      Invoked when a hardware key is pressed or released.

      This method is typically invoked in response to the press of a physical keyboard key or a D-pad button. It is generally not invoked when a virtual software keyboard is used, though a software keyboard may choose to invoke this method in some situations.

      `KeyEvent`s are sent from Android to Flutter. `AndroidKeyProcessor` may do some additional work with the given `KeyEvent`, e.g., combine this `keyCode` with the previous `keyCode` to generate a unicode combined character.

      Overrides:
        `dispatchKeyEvent` in class `ViewGroup`

    - #### onTouchEvent

          public boolean onTouchEvent(@NonNull
                                      MotionEvent event)

      Invoked by Android when a user touch event occurs.

      Flutter handles all of its own gesture detection and processing, therefore this method forwards all `MotionEvent` data from Android to Flutter.

      Overrides:
        `onTouchEvent` in class `View`

    - #### onGenericMotionEvent

          public boolean onGenericMotionEvent(@NonNull
                                              MotionEvent event)

      Invoked by Android when a generic motion event occurs, e.g., joystick movement, mouse hover, track pad touches, scroll wheel movements, etc.

      Flutter handles all of its own gesture detection and processing, therefore this method forwards all `MotionEvent` data from Android to Flutter.

      Overrides:
        `onGenericMotionEvent` in class `View`

    - #### onHoverEvent

          public boolean onHoverEvent(@NonNull
                                      MotionEvent event)

      Invoked by Android when a hover-compliant input system causes a hover event.

      An example of hover events is a stylus sitting near an Android screen. As the stylus moves from outside a `View` to hover over a `View`, or move around within a `View`, or moves from over a `View` to outside a `View`, a corresponding `MotionEvent` is reported via this method.

      Hover events can be used for accessibility touch exploration and therefore are processed here for accessibility purposes.

      Overrides:
        `onHoverEvent` in class `View`

    - #### getAccessibilityNodeProvider

          @Nullable
          public AccessibilityNodeProvider getAccessibilityNodeProvider()

      Overrides:
        `getAccessibilityNodeProvider` in class `View`

    - #### getSystemPointerIcon

          @NonNull
          public PointerIcon getSystemPointerIcon(int type)

      Description copied from interface: `io.flutter.plugin.mouse.MouseCursorPlugin.MouseCursorViewDelegate`
      Gets a system pointer icon object for the given `type`.

      If typeis not recognized, returns the default pointer icon.

      This is typically implemented by calling `PointerIcon.getSystemIcon` with the context associated with this view.

      Specified by:
        `getSystemPointerIcon` in interface `io.flutter.plugin.mouse.MouseCursorPlugin.MouseCursorViewDelegate`

    - #### attachToFlutterEngine

          public void attachToFlutterEngine(@NonNull
                                            FlutterEngine flutterEngine)

      Connects this `FlutterView` to the given `FlutterEngine`.

      This `FlutterView` will begin rendering the UI painted by the given `FlutterEngine`. This `FlutterView` will also begin forwarding interaction events from this `FlutterView` to the given `FlutterEngine`, e.g., user touch events, accessibility events, keyboard events, and others.

      See `detachFromFlutterEngine()` for information on how to detach from a `FlutterEngine`.

    - #### detachFromFlutterEngine

          public void detachFromFlutterEngine()

      Disconnects this `FlutterView` from a previously attached `FlutterEngine`.

      This `FlutterView` will clear its UI and stop forwarding all events to the previously-attached `FlutterEngine`. This includes touch events, accessibility events, keyboard events, and others.

      See `attachToFlutterEngine(FlutterEngine)` for information on how to attach a `FlutterEngine`.

    - #### createImageView

          @NonNull
          public FlutterImageView createImageView()

    - #### convertToImageView

          public void convertToImageView()

      Converts the current render surface to a `FlutterImageView` if it's not one already. Otherwise, it resizes the `FlutterImageView` based on the current view size.

    - #### revertImageView

          public void revertImageView(@NonNull
                                      Runnable onDone)

      If the surface is rendered by a `FlutterImageView`, then calling this method will stop rendering to a `FlutterImageView`, and render on the previous surface instead.
      Parameters:
        `onDone` - a callback called when Flutter UI is rendered on the previous surface. Use this callback to perform cleanups. For example, destroy overlay surfaces.

    - #### attachOverlaySurfaceToRender

          public void attachOverlaySurfaceToRender(FlutterImageView view)

    - #### acquireLatestImageViewFrame

          public boolean acquireLatestImageViewFrame()

    - #### isAttachedToFlutterEngine

          public boolean isAttachedToFlutterEngine()

      Returns true if this `FlutterView` is currently attached to a `FlutterEngine`.

    - #### getAttachedFlutterEngine

          @Nullable
          public FlutterEngine getAttachedFlutterEngine()

      Returns the `FlutterEngine` to which this `FlutterView` is currently attached, or null if this `FlutterView` is not currently attached to a `FlutterEngine`.

    - #### addFlutterEngineAttachmentListener

          public void addFlutterEngineAttachmentListener(@NonNull
                                                         FlutterView.FlutterEngineAttachmentListener listener)

      Adds a `FlutterView.FlutterEngineAttachmentListener`, which is notified whenever this `FlutterView` attached to/detaches from a `FlutterEngine`.

    - #### removeFlutterEngineAttachmentListener

          public void removeFlutterEngineAttachmentListener(@NonNull
                                                            FlutterView.FlutterEngineAttachmentListener listener)

      Removes a `FlutterView.FlutterEngineAttachmentListener` that was previously added with `addFlutterEngineAttachmentListener(FlutterEngineAttachmentListener)`.

    - #### onProvideAutofillVirtualStructure

          public void onProvideAutofillVirtualStructure(ViewStructure structure,
                                                        int flags)

      Overrides:
        `onProvideAutofillVirtualStructure` in class `View`

    - #### autofill

          public void autofill(SparseArray<AutofillValue> values)

      Overrides:
        `autofill` in class `View`